CodeForces - 1047CEnlarge GCD(这题很难,快来看题解,超级详细,骗浏览量)
C. Enlarge GCD
time limit per test1 second
memory limit per test256 megabytes
inputstandard input
outputstandard output
Mr. F has n positive integers, a1,a2,…,an.
He thinks the greatest common divisor of these integers is too small. So he wants to enlarge it by removing some of the integers.
But this problem is too simple for him, so he does not want to do it by himself. If you help him, he will give you some scores in reward.
Your task is to calculate the minimum number of integers you need to remove so that the greatest common divisor of the remaining integers is bigger than that of all integers.
Input
The first line contains an integer n (2≤n≤3⋅105) — the number of integers Mr. F has.
The second line contains n integers, a1,a2,…,an (1≤ai≤1.5⋅107).
Output
Print an integer — the minimum number of integers you need to remove so that the greatest common divisor of the remaining integers is bigger than that of all integers.
You should not remove all of the integers.
If there is no solution, print «-1» (without quotes).
Examples
inputCopy
3
1 2 4
outputCopy
1
inputCopy
4
6 9 15 30
outputCopy
2
inputCopy
3
1 1 1
outputCopy
-1
Note
In the first example, the greatest common divisor is 1 in the beginning. You can remove 1 so that the greatest common divisor is enlarged to 2. The answer is 1.
In the second example, the greatest common divisor is 3 in the beginning. You can remove 6 and 9 so that the greatest common divisor is enlarged to 15. There is no solution which removes only one integer. So the answer is 2.
In the third example, there is no solution to enlarge the greatest common divisor. So the answer is −1.
这道题是说删最少的数字使得,数列的最大公约增大。这道题要明白第一点,输出-1的情况,当输入数字都是一样的时候,其他情况全都有解,至少有一个N-1的解。
先对数列求整体的最小公倍数。假设第一个与第二个的小公倍数a=gcd(x1,x2)则第二个与第三个的是b=gcd(a,x3),即x1,x2,x3的最小公倍数。以此类推即可求出所有数的最大公约数,本以为会超时,没想到922ms过了。 那么要想变大,就要从比最大公约数大一个的开始枚举,好在如果先枚举过2之后4,6,8,就都不用枚举了,实际上是没举素数,但是埃氏筛法也很费时间,加上就超时,这里就用了埃氏筛法的思想。我是用桶的方法存的数据,不然重复元素不好处理,这样根据下标就能判断这个数在哪里,有几个。每次枚举出的都是按最大公约数枚举,这样刚好能处理。
ps:
2 4 8 18 34 44
最大公约数是2
从3开始枚举
cnt+=a[3]=0;
cnt+=a[6]=0;
…
cnt+=a[18]=1;
…
ans=5;
然后是4;
cnt=3;
ans=4;
然后是5
cnt=0;
ans=6;
布拉布拉,就写就是了。
上界肯定是比第一大数小的数,但是小多少,不清楚,直接枚举到最大数即可。刚刚有优化了一下,发现很多地方都可以减少时间消耗。跑出来了700ms的好成绩,哈哈哈哈。
#include <bits/stdc++.h>
using namespace std;
const int MAX =1.5e7 + 10;
int jishu[MAX], a[MAX];
int flag=0,maxn=0 ,n, d = 0, ob;
int main()
{
scanf("%d",&n);
for (int i=0; i<n; ++i)
{
scanf("%d", &ob);
maxn=max(maxn,ob);
a[ob]++;
if (i==0)d = ob;
d = __gcd(d,ob);//艾玛,省老多事了。
}
if(a[ob]==n)
{
printf("-1\n");
return 0;
}
int ans = n;
for (int i=d + 1;i<=maxn; ++i)
if (jishu[i]==0)
{
int ct = 0;
for (int j = i; j <= maxn; j += i)
jishu[j] = 1, ct += a[j];
ans = min(ans,n-ct);
}
printf("%d\n",ans);
return 0;
}
CodeForces - 1047CEnlarge GCD(这题很难,快来看题解,超级详细,骗浏览量)的更多相关文章
- 30 整数中1出现的次数(从1到n整数中1出现的次数)这题很难要多看*
题目描述 求出1~13的整数中1出现的次数,并算出100~1300的整数中1出现的次数?为此他特别数了一下1~13中包含1的数字有1.10.11.12.13因此共出现6次,但是对于后面问题他就没辙了. ...
- Codeforces 1291 Round #616 (Div. 2) C. Mind Control(超级详细)
C. Mind Control You and your n−1 friends have found an array of integers a1,a2,-,an. You have decide ...
- CodeForces 610B-Vika and Squares,有坑点,不是很难~~
B. Vika and Squares time limit per test 2 seconds memory limit per test 256 megabytes input standard ...
- 函数式编程很难,这正是你要学习它的原因 | 外刊IT评论网
函数式编程很难,这正是你要学习它的原因 | 外刊IT评论网 函数式编程很难,这正是你要学习它的原因 156 次分享 新浪微博 腾讯微博 Tweet 人人网 QQ空间 很奇怪不是,很少有人每天都使用函数 ...
- CodeForces - 468A ——(思维题)
Little X used to play a card game called "24 Game", but recently he has found it too easy. ...
- codeforces 407 div1 B题(Weird journey)
codeforces 407 div1 B题(Weird journey) 传送门 题意: 给出一张图,n个点m条路径,一条好的路径定义为只有2条路径经过1次,m-2条路径经过2次,图中存在自环.问满 ...
- 听说 JVM 性能优化很难?今天我小试了一把!
文章首发于公众号「陈树义」及个人博客 shuyi.tech,欢迎关注访问. 对于 Java 开发的同学来说,JVM 性能优化可以说是比较难掌握的知识点.这不仅因为 JVM 性能优化需要掌握晦涩难懂的 ...
- java 基础题 很基础, 很有趣
都是一些非常非常基础的题,是我最近参加各大IT公司笔试后靠记忆记下来的,经过整理献给与我一样参加各大IT校园招聘的同学们,纯考Java基础功底, 老手们就不用进来了,免得笑话我们这些未出校门的孩纸们, ...
- 转:Eric Lippert:阅读代码真的很难
转自:http://blog.jobbole.com/438/ 相关文章 微软资深软件工程师:阅读代码真的很难(第2篇) 阅读优秀代码是提高开发人员修为的一种捷径 学会阅读源代码 如何阅读大型代码库? ...
随机推荐
- c#声明数组
声明二维数组时候,出现报错: string[][] dataTable; dataTable = new string[rows][cols]; 无效的秩说明符: 应为","或&q ...
- MTK Android 如何获取系统权限
Android如何获得系统(system)权限 Android中如何修改系统时间(应用程序获得系统权限) 在 android 的API中有提供 SystemClock.setCurrentTimeMi ...
- VSCode——自定义VSCode背景图片
本文转载自https://blog.csdn.net/yukinoai/article/details/84564949 1.以管理员身份运行VS Code,安装background插件 2.打开se ...
- go 闭包函数
一.什么是闭包函数? 二.匿名函数可以被赋值给变量并作为值使用: package main import "fmt" func main(){ f() } func f(){ fo ...
- CSS躬行记(5)——渐变
渐变是由两种或多种颜色之间的渐进过渡组成,它是一种特殊的图像类型,分为线性渐变和径向渐变,这两类渐变还会细分为单次和重复两种.渐变图像与传统图像相比,它的优势包括占用更少的字节,避免额外的服务器请求, ...
- 中阶 d04 xml 概念及使用
idea新建xml文件https://www.jianshu.com/p/b8aeadae39b0 或https://blog.csdn.net/Hi_Boy_/article/details/804 ...
- SQL基础系列(4)-性能优化建议
10.1 连接查询表的顺序问题 SQLSERVER的解析器按照从右到左的顺序处理FROM子句中的表名,因此FROM子句中写在最后的表(基础表driving table)将被最先处理,在FROM子句中包 ...
- CH5E07 划分大理石(背包dp+二进制拆分)
传送门 大意: 有价值分别为1..6的大理石各a[1..6]块,现要将它们分成两部分,使得两部分价值之和相等,问是否可以实现.其中大理石的总数不超过20000. 解题思路: 妥妥的多重背包+二 ...
- 【python实现卷积神经网络】卷积层Conv2D反向传播过程
代码来源:https://github.com/eriklindernoren/ML-From-Scratch 卷积神经网络中卷积层Conv2D(带stride.padding)的具体实现:https ...
- Thinking in Java,Fourth Edition(Java 编程思想,第四版)学习笔记(一)之Introduction
Learn Java I found out that I and other speakers tended to give the typical audience too many topics ...